"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var kamboja_core_1 = require("kamboja-core");
var AttachableInvocation = /** @class */ (function (_super) {
    tslib_1.__extends(AttachableInvocation, _super);
    function AttachableInvocation(middlewares, controllerInfo, facade) {
        var _this = _super.call(this) || this;
        _this.middlewares = middlewares;
        _this.controllerInfo = controllerInfo;
        _this.facade = facade;
        return _this;
    }
    AttachableInvocation.prototype.attach = function (invocation) {
        invocation.controllerInfo = this.controllerInfo;
        invocation.middlewares = this.middlewares;
        invocation.facade = this.facade;
        this.invocation = invocation;
    };
    AttachableInvocation.prototype.proceed = function () {
        this.invocation.context = this.context;
        this.invocation.parameters = this.parameters;
        return this.invocation.proceed();
    };
    return AttachableInvocation;
}(kamboja_core_1.Invocation));
exports.AttachableInvocation = AttachableInvocation;
